SystemOrganization addCategory: #'FileSystem-Zip'!

!FileSystem class methodsFor: '*filesystem-zip' stamp: 'EstebanLorenzano 4/3/2012 17:21'!
inZip: aReference
	self deprecated: 'Use #zip:' on: '3 April 2012' in: 'Pharo 1.4'. 
	^ self zip: aReference ! !

!FileSystem class methodsFor: '*filesystem-zip' stamp: 'EstebanLorenzano 4/3/2012 17:20'!
zip: aReference
	^ self store: (ZipStore reference: aReference)! !

MemoryStore subclass: #ZipStore
	instanceVariableNames: 'reference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Zip'!

!ZipStore commentStamp: '<historical>' prior: 0!
I'm a specific store for Zip file systems!

!ZipStore class methodsFor: 'as yet unclassified' stamp: 'cwp 2/18/2011 23:46'!
reference: aReference
	^ self basicNew
		initializeWithReference: aReference
		yourself! !

!ZipStore methodsFor: 'public' stamp: 'EstebanLorenzano 4/2/2012 11:43'!
close
	| archive fs stream |
	archive := ZipArchive new.
	fs := FileSystem store: self.
	fs root allChildren do: 
		[ :each | 
		each isFile ifTrue: 
			[ each readStreamDo: 
				[ :output | 
				archive addString: output contents as: each path printString ] ] ].
	archive
		writeTo: (stream := WriteStream on: ByteArray new);
		close.
	self reference writeStreamDo: 
		[ :output | output nextPutAll: stream contents ]! !

!ZipStore methodsFor: 'as yet unclassified' stamp: 'cwp 2/18/2011 23:49'!
initializeWithReference: aReference
	self initialize.
	reference := aReference! !

!ZipStore methodsFor: 'public' stamp: 'cwp 2/19/2011 01:41'!
open
	| archive output |
	self reference exists
		ifFalse: [ ^ self ].
	archive := ZipArchive new.
	self reference
		readStreamDo: [ :input | 
			archive readFrom: input contents readStream.
			archive members
				do: [ :member | 
					| path |
					path := self pathFromMember: member.
					member isDirectory
						ifTrue: [ self ensureDirectory: path ]
						ifFalse: [ 
							self ensureDirectory: path parent.
							self createFile: path.
							self
								replaceFile: path
								in: [ :bytes | 
									output := bytes writeStream.
									member rewindData.
									member copyRawDataTo: output.
									output contents ] ] ] ].
	^ self! !

!ZipStore methodsFor: 'private' stamp: 'EstebanLorenzano 4/2/2012 11:42'!
pathFromMember: anArchiveMember
	| path |
	path := Path root resolve: anArchiveMember fileName.
	^ path basename isEmpty
		ifTrue: [ path parent ]
		ifFalse: [ path ]! !

!ZipStore methodsFor: 'as yet unclassified' stamp: 'cwp 2/18/2011 23:49'!
reference
	^ reference! !
